typedef double (*func_f1) (double);
typedef double (*func_f2) (double, double);
typedef double (*func_f3) (double, double, double);
typedef double (*func_f2tv) (double, vector<double>);

class CFunc { // public (short) interface => TAKE CARE
 public:
    string s;
    int narg;
    func_f1 f1;
    func_f2 f2;
    func_f3 f3;
    func_f2tv f2tv;
    class CCoord coord(class CCoord *co) const;
    class CCoord coord(class CCoord *co1, class CCoord *co2) const;
    class CCoord coord(class CCoord *co1, class CCoord *co2,
                       class CCoord *co3) const;
    CFunc(string name_in, double(*f_in)(double)) {
        // cout << "DEBUG create CFunc(1) ["<<name_in<<"]\n";
        s = name_in;
        narg = 1;
        f1 = f_in;
    };
    CFunc(string name_in, double(*f_in)(double, double)) {
        // cout << "DEBUG create CFunc(2) ["<<name_in<<"]\n";
        s = name_in;
        narg = 2;
        f2 = f_in;
    };
    CFunc(string name_in, double(*f_in)(double, double, double)) {
        // cout << "DEBUG create CFunc(3) ["<<name_in<<"]\n";
        s = name_in;
        narg = 3;
        f3 = f_in;
    };
    CFunc(string name_in, double(*f_in)(double, vector<double>)) {
        // cout << "DEBUG create CFunc(2) ["<<name_in<<"]\n";
        s = name_in;
        narg = 2;
        f2tv = f_in;
    };
};

namespace NFunctions { // public (short) interface
    void Register(void);
    CFunc* find(string nam);
};

extern double func_neg(double);
extern double func_inv(double);
extern double func_ln(double);
extern double func_lg(double);
extern double func_i_ln(double);
extern double func_i_lg(double);
extern double func_sqr(double);
extern double func_sqrt(double);
extern double func_abs(double);
extern double func_exp(double);
extern double func_sin(double);
extern double func_cos(double);
extern double func_tan(double);
extern double func_sind(double);
extern double func_cosd(double);
extern double func_tand(double);
extern double func_cotd(double);
extern double func_asin(double);
extern double func_acos(double);
extern double func_atan(double);
extern double func_asind(double);
extern double func_acosd(double);
extern double func_atand(double);
extern double func_acotd(double);
extern double func_gamma(double);
extern double func_erfP(double); // (1/sqrt(2\pi) \int_{-\infty}^x\exp(-t^2/2)dt
extern double func_erfQ(double); // 1-erfP
extern double func_erf(double);  // error function: .. \int_0^x \exp(-t^2) dt
extern double func_erfc(double);
extern double func_sinc(double);
extern double func_ceil(double);  // smallest int >= arg
extern double func_floor(double); // largest  int <= arg
extern double func_nint(double);  // nearest int

extern double func_not(double);

extern double func_2nd(double,double);
extern double func_add(double,double);
extern double func_sub(double,double);
extern double func_mul(double,double);
extern double func_div(double,double);
extern double func_2div(double,double);
extern double func_pow(double,double);

extern double func_eq(double,double);
extern double func_ne(double,double);
extern double func_gt(double,double);
extern double func_ge(double,double);
extern double func_lt(double,double);
extern double func_le(double,double);
extern double func_and(double,double);
extern double func_or(double,double);
extern double func_xor(double,double);
extern double func_mod(double,double);
extern double func_idiv(double,double);
extern double func_over(double,double);
extern double func_kwwc( double v, double a);
extern double func_kwws( double v, double a);

extern double func_in( double, vector<double> );

extern double func_min(double,double);
extern double func_max(double,double);
extern double func_gauss(double,double);
extern double func_gaussnn(double,double);
extern double func_cauchy(double,double);

extern double func_ran(double,double);

extern double func_condass(double,double,double); // conditional assignement
extern double func_q4w(double,double,double);

extern double func_cauchy2(double,double,double);

extern double func_data_intp_lin( double v, double dk, double dj );
